Listing 2.

[There were a couple of mistakes in the hex code in the printed]
[listing, which I've corrected here.                       JimG]

                      TRON & TROFF
Add  hexcode  label   Assembler        Comments
FE7E F3       TRON    DI               switch off interrupts
FE7F 3EFE             LD   A,#FE       set up vector address
FE81 ED47             LD   I,A         to FEFF
FE83 ED5E             IM   2           select mode 2
FE85 FB               EI               switch on interrupts
FE86 C9               RET              return to BASIC
FE87 F3       TROFF   DI               interrupts off
FE89 3E3F             LD   A,#3F       restore the interrupt
FE8A ED47             LD   I,A         vector address to 3FFF
FE8C ED56             IM   1           restore mode 1
FE8E FB               EI               interrupts on
FE8F C9               RET              return

                      TRQ
              ELINE   EQU  5C59H
              VARS    EQU  5C4BH
                      ORG  FE90H
FE90 2A595C   TRQ     LD   HL,(ELINE)  calculate the length
FE93 ED5B4B5C         LD   DE,(VARS)   of variables area
FE97 A7               AND  A
FE98 ED52             SBC  HL,DE
FE9A E5               PUSH HL          put length into BC
FE9B C1               POP  BC
FE9C EB               EX   DE,HL       put variables start into HL
FE9D 3EB4     SEARCH  LD   A,#B4       put code for 't' as first letter into A
FE9F EDB1             CPIR             carry out search
FEA1 2806             JR   Z,FOUND
FEA3 78               LD   A,B         end of variables?
FEA4 B1               OR   C
FEA5 2824             JR   Z,ZERO      if so then there is no trace
FEA7 18F4             JR   SEARCH      search on
FEA9 3E72     FOUND   LD   A,#72       is next letter 'r'?
FEAB BE               CP   (HL)
FEAC 20EF             JR   NZ,SEARCH   search on if not
FEAE 23               INC  HL          is next byte 'a'?
FEAF 3E61             LD   A,#61
FEB1 BE               CP   (HL)
FEB2 20E9             JR   NZ,SEARCH
FEB4 23               INC  HL          is next byte 'c'?
FEB5 3E63             LD   A,#63
FEB7 BE               CP   (HL)
FEB8 20E3             JR   NZ,SEARCH
FEBA 23               INC  HL          is next byte last letter
FEBB 3EE5             LD   A,#E5       and is it 'e'?
FEBD BE               CP   (HL)
FEBE 20DD             JR   NZ,SEARCH
FEC0 23               INC  HL          jump over first byte
FEC1 23               INC  HL
FEC2 7E               LD   A,(HL)      look at sign byte
FEC3 3C               INC  A           jump forward if negative
FEC4 280A             JR   Z,NEG
FEC6 23               INC  HL          is next byte 1?
FEC7 7E               LD   A,(HL)
FEC8 3D               DEC  A
FEC9 2802             JR   Z,ONE       jump forward if it is
FECB AF       ZERO    XOR  A           trace must be 0 so load
FECC C9               RET              A with 0 and return
FECD 3E01     ONE     LD   A,#01       load A with 1 and
FECF C9               RET              return
FED0 3EFF     NEG     LD   A,#FF       load A with -1 and return
FED2 C9               RET

                      PRINT
                      ORG  FED3H
FED3 E5       PRINT   PUSH HL          save HL
FED4 211840           LD   HL,#4018    screen address
FED7 5F               LD   E,A         get print position
FED8 1600             LD   D,#00       into DE
FEDA 19               ADD  HL,DE
FEDB EB               EX   DE,HL
FEDC 0600             LD   B,#00
FEDE 21803D           LD   HL,#3D80    character position for '0'
FEE1 79               LD   A,C         get digit into A
FEE2 87               ADD  A,A         multiply by 8
FEE3 87               ADD  A,A
FEE4 87               ADD  A,A
FEE5 4F               LD   C,A         and put into C
FEE6 00               NOP
FEE7 09               ADD  HL,BC       calculate position in table
FEE8 0608             LD   B,#08       there are 8 bytes
FEEA 7E       LOOP1   LD   A,(HL)      pick up bytes
FEEB 2F               CPL              invert byte
FEEC 12               LD   (DE),A      print it
FEED 14               INC  D           next pixel line 256 bytes further on
FEEE 23               INC  HL          next byte
FEEF 10F9             DJNZ LOOP1       all 8 bytes
FEF1 E1               POP  HL          restore HL
FEF2 C9               RET

                      COUNT & LINE
                      ORG  FEF3H
              PPC     EQU  5C45H
              PRINT   EQU  FED3H
FEF3 0E00     COUNT   LD   C,#00       set counter to 0
FEF5 0C       LOOP2   INC  C           increase count each time through loop
FEF6 A7               AND  A
FEF7 ED52             SBC  HL,DE       perform subtractions
FEF9 30FA             JR   NC,LOOP2    repeat till past 0
FEFB 0D               DEC  C
FEFC 19               ADD  HL,DE       and difference back
FEFD 1802             JR   JUMP        jump over vector 
FEFF 2D               DEFB 2DH         the vector (FF2D is MAIN)
FF00 FF               DEFB FFH
FF01 C9       JUMP    RET
FF02 2A455C   LINE    LD   HL,(PPC)    pick up line number
FF05 11E803           LD   DE,#03E8    a thousand
FF08 CDF3FE           CALL COUNT       how many thousands
FF0B 3E01             LD   A,#01       first digit
FF0D CDD3FE           CALL PRINT       print it
FF10 116400           LD   DE,#0064    now hundreds
FF13 CDF3FE           CALL COUNT
FF16 3E02             LD   A,#02       second digit
FF18 CDD3FE           CALL PRINT
FF1B 110A00           LD   DE,#000A    tens next
FF1E CDF3FE           CALL COUNT
FF21 3E03             LD   A,#03       third digit
FF23 CDD3FE           CALL #FED3
FF26 4D               LD   C,L         now the units
FF27 3E04             LD   A,#04       fourth digit
FF29 CDD3FE           CALL #FED3
FF2C C9               RET

                      MAIN
                      ORG  FF2DH
              PPCH    EQU  5C46H
              TRQ     EQU  FE90H
              LINE    EQU  FF02H
              TROFF   EQU  FE87H
FF2D FF       MAIN    RST  #38         carry out normal interrupt routine
FF2E F5               PUSH AF          save A & F
FF2F 3A465C           LD   A,(PPCH)    is a program running?
FF32 3C               INC  A           PPCH holds FF if not running a program
FF33 2002             JR   NZ,RUN      jump if it is
FF35 F1               POP  AF          restore flags and 
FF36 C9               RET              return
FF37 C5       RUN     PUSH BC          save all regs
FF38 D5               PUSH DE
FF39 E5               PUSH HL
FF3A CD90FE           CALL TRQ         check variable 'trace'
FF3D 3D               DEC  A           if A not 1 then jump
FF3E 2005             JR   NZ,NOTON    forward
FF40 CD02FF           CALL LINE        perform trace
FF43 1806             JR   RTN         jump to return
FF45 3C      NOTON    INC  A           is 'trace' 0? If so then
FF46 2803             JR   Z,RTN       just return
FF48 CD87FE           CALL TROFF       disable trace
FF4B E1      RTN      POP  HL          restore regs
FF4C D1               POP  DE
FF4D C1               POP  BC
FF4E F1               POP  AF
FF4F C9               RET              return to BASIC

